import requests
import xml.etree.ElementTree as ET

TdsAddress = "https://192.168.100.22"

User = "admin"
Pass = "spotweld"


def read_file(file_name):
    with open(file_name) as f:
        return f.read()


# Get the authentication token
tokenXml = requests.post(
    f"{TdsAddress}/users/get_token",
    verify=False,
    data=f"User[login]={User}&User[password]={Pass}",
)
token = ET.fromstring(tokenXml.text).text

def post(endpoint: str, data: str, id_path: str = None):
    response = requests.post(
        f"{TdsAddress}/{endpoint}",
        verify=False,
        data=data,
    )
    if id_path is not None:
        response_xml = ET.fromstring(response.text)
        return response_xml.find(id_path).text

part_xml = read_file("part.xml")
weld1_xml = read_file("weld1.xml")
weld2_xml = read_file("weld2.xml")
weld3_xml = read_file("weld3.xml")
image1_xml = read_file("image1.xml")
image2_xml = read_file("image2.xml")
hotspot1_xml = read_file("hotspot1.xml")
hotspot2_xml = read_file("hotspot2.xml")
hotspot3_xml = read_file("hotspot3.xml")
route_xml = read_file("route.xml")
route_items_xml = read_file("route_items.xml")


# create part
part_id = post("parts", part_xml, "Part/id")

# upload the welds
weld1_id = post("welds", weld1_xml.format(part_id=part_id), "Weld/id")
weld2_id = post("welds", weld2_xml.format(part_id=part_id), "Weld/id")
weld3_id = post("welds", weld3_xml.format(part_id=part_id), "Weld/id")

# upload the images
image1_id = post("images", image1_xml.format(part_id=part_id), "Image/id")
image2_id = post("images", image2_xml.format(part_id=part_id), "Image/id")

# upload the hotspots
post("hot_spots", hotspot1_xml.format(image_id=image2_id, weld_id=weld1_id))
post("hot_spots", hotspot2_xml.format(image_id=image1_id, weld_id=weld2_id))
post("hot_spots", hotspot3_xml.format(image_id=image1_id, weld_id=weld3_id))

# upload the route
route_id = post("routes", route_xml.format(part_id=part_id), "Route/id")

# upload the route_items
post("route_items", route_items_xml.format(route_id=route_id, weld_id=weld1_id, image_id=image2_id))
post("route_items", route_items_xml.format(route_id=route_id, weld_id=weld2_id, image_id=image1_id))
post("route_items", route_items_xml.format(route_id=route_id, weld_id=weld3_id, image_id=image1_id))
